// mshtmlhookDlg.cpp : implementation file
//

#include "stdafx.h"
#include "mshtmlhook.h"
#include "mshtmlhookDlg.h"
#include "DlgProxy.h"
#include "comdef.h"

#include "DHTMLEventSink.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

long indexN = 0;


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMshtmlhookDlg dialog

IMPLEMENT_DYNAMIC(CMshtmlhookDlg, CDialog);

CMshtmlhookDlg::CMshtmlhookDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMshtmlhookDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMshtmlhookDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pAutoProxy = NULL;
}

CMshtmlhookDlg::~CMshtmlhookDlg()
{
	// If there is an automation proxy for this dialog, set
	//  its back pointer to this dialog to NULL, so it knows
	//  the dialog has been deleted.
	if (m_pAutoProxy != NULL)
		m_pAutoProxy->m_pDialog = NULL;
}

void CMshtmlhookDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMshtmlhookDlg)
	DDX_Control(pDX, IDC_EXPLORER1, m_ie);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMshtmlhookDlg, CDialog)
	//{{AFX_MSG_MAP(CMshtmlhookDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMshtmlhookDlg message handlers

BOOL CMshtmlhookDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	m_ie.Navigate("res://mshtmlhook.exe/mshtmldemo.htm", NULL,NULL,NULL,NULL);

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMshtmlhookDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMshtmlhookDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMshtmlhookDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// Automation servers should not exit when a user closes the UI
//  if a controller still holds on to one of its objects.  These
//  message handlers make sure that if the proxy is still in use,
//  then the UI is hidden but the dialog remains around if it
//  is dismissed.




 
 
BOOL CMshtmlhookDlg::CanExit()
{
	// If the proxy object is still around, then the automation
	//  controller is still holding on to this application.  Leave
	//  the dialog around, but hide its UI.
	if (m_pAutoProxy != NULL)
	{
		ShowWindow(SW_HIDE);
		return FALSE;
	}

	return TRUE;
}

BEGIN_EVENTSINK_MAP(CMshtmlhookDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CMshtmlhookDlg)
	ON_EVENT(CMshtmlhookDlg, IDC_EXPLORER1, 259 /* DocumentComplete */, OnDocumentCompleteExplorer1, VTS_DISPATCH VTS_PVARIANT)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()


void CMshtmlhookDlg::OnDocumentCompleteExplorer1(LPDISPATCH pDisp, VARIANT FAR* URL) 
{

	//Only if it is the main window not a frame
	IWebBrowser2* spTemp;
	
	pDisp->QueryInterface(IID_IWebBrowser2, (void**)&spTemp);

	
	/////////////////////////////////////////////////////////////
	IDispatch* pDocDisp = NULL;
    
	IHTMLDocument2* pDoc = NULL;
    
	spTemp->get_Document(&pDocDisp);
	
	pDocDisp->QueryInterface(IID_IHTMLDocument2, (void**)&pDoc);

    //Create a option element.
	m_pDoc = pDoc;

	/*	
	CString newElem("OPTION");

	BSTR bstrElem = newElem.AllocSysString();
	
	HRESULT hr = pDoc->createElement(bstrElem, &m_pNewElem);
    */
	
	
	/////////////////////////////////////////////////////////////

	IHTMLElementCollection* pElemColl = NULL;

    pDoc->get_all(&pElemColl);
   
        
	////////////////////////////////////////////////////////
    //   enumerate DHTML element 
	////////////////////////////////////////////////////////
    
	LONG celem;

	pElemColl->get_length(&celem);

    
	for(int i = 0; i < celem; i++)
	{
		VARIANT varIndex;
        varIndex.vt = VT_UINT;
        varIndex.lVal = i;
        
		VARIANT var2;
        VariantInit( &var2 );
        
		IDispatch* pDisp; 

        //////////////////////////
		HRESULT hr = pElemColl->item( varIndex, var2, &pDisp );
        
		if ( hr == S_OK )
        {
             IHTMLElement* pElem;

             hr = pDisp->QueryInterface(IID_IHTMLElement,(void **)&pElem);
             
			 if ( hr == S_OK )
             {
                 
				 BSTR bstrId = 0;
                 
				 hr = pElem->get_id(&bstrId);
                 			 
				 CString strId(bstrId);                  
								 
				 //connect to Button1 connection point.
                 if(strId.Find("B1",0) != -1){
				     
					 IHTMLButtonElement* pButtonElem = NULL;

					 hr = pDisp->QueryInterface(IID_IHTMLButtonElement, (void **)&pButtonElem); 
						    			 
					 
					 ConnectButton1(pButtonElem);	 
  				 
				     				 
				 }   
					  
			 	 
                 //connect to Button2 connection point.
                 if(strId.Find("B2",0) != -1){
				     
					 IHTMLButtonElement* pButtonElem = NULL;

					 hr = pDisp->QueryInterface(IID_IHTMLButtonElement, (void **)&pButtonElem); 
							 
				     ConnectButton2(pButtonElem);	 
  								     				 
				 }   


			     //find out selection elements.
                 if(strId.Find("select1",0) != -1){
		  	 				 
			         IHTMLSelectElement* pSelElem = NULL;

					 hr = pDisp->QueryInterface(IID_IHTMLSelectElement, (void **)&pSelElem); 
							 
					 m_SelElem = pSelElem;  	     				 
				 
				 }   
				 			 
				 
				 ::SysFreeString(bstrId);
				 
				  pElem->Release(); 
				 
				 
			 }
		     pDisp->Release();
		}

    }
	
    //pDoc->Release();	




}


void CMshtmlhookDlg::ConnectButton1(IHTMLButtonElement* pButtonElem)
{

    ////////////////////////////////////////////////////////
	HRESULT hr = 0;
    
	IConnectionPointContainer* pCPC = NULL;
    
	IConnectionPoint* pCP = NULL;
    
	IUnknown* pUnk = NULL;
	
	DWORD dwCookie;

    // Check that this is a connectable object.
    hr = pButtonElem->QueryInterface(IID_IConnectionPointContainer, (void**)&pCPC);

    if (hr == S_OK)
    {
        		
		//AfxMessageBox("ConnectionPointContainer");
		// Find the connection point.
        hr = pCPC->FindConnectionPoint(DIID_HTMLButtonElementEvents2, &pCP);

        		
		if (hr == S_OK)
        {
            
			//AfxMessageBox("Find connection point ");
			// Advise the connection point.
            // pUnk is the IUnknown interface pointer for your event sink
            
			CDHTMLEventSink* pSink = new CDHTMLEventSink;
 
            pSink->SetParent(this);
			
			IUnknown* pUnk = pSink->GetInterface(&IID_IUnknown);
			
			hr = pCP->Advise(pUnk, &dwCookie);
            
			
			
			pCP->Release();
        }
	

        pCPC->Release();
    }
    
	

}




void CMshtmlhookDlg::ConnectButton2(IHTMLButtonElement* pButtonElem)
{

      ////////////////////////////////////////////////////////
	HRESULT hr = 0;
    
	IConnectionPointContainer* pCPC = NULL;
    
	IConnectionPoint* pCP = NULL;
    
	IUnknown* pUnk = NULL;
	
	DWORD dwCookie;

    // Check that this is a connectable object.
    hr = pButtonElem->QueryInterface(IID_IConnectionPointContainer, (void**)&pCPC);

    if (hr == S_OK)
    {
        		
		//AfxMessageBox("ConnectionPointContainer");
		// Find the connection point.
        hr = pCPC->FindConnectionPoint(DIID_HTMLButtonElementEvents2, &pCP);

        		
		if (hr == S_OK)
        {
            
			//AfxMessageBox("Find connection point ");
			// Advise the connection point.
            // pUnk is the IUnknown interface pointer for your event sink
            
			CDHTMLEventSink* pSink = new CDHTMLEventSink;

            pSink->SetParent(this);
			
			IUnknown* pUnk = pSink->GetInterface(&IID_IUnknown);
			
			hr = pCP->Advise(pUnk, &dwCookie);
            	
			
			pCP->Release();
        }
	

        pCPC->Release();
    }


}



void CMshtmlhookDlg::DisplayEvent(CString elemInfo)
{
    
    HRESULT hr = 0;

	CString newElem("OPTION");

	BSTR bstrElem = newElem.AllocSysString();
	
	hr = m_pDoc->createElement(bstrElem, &m_pNewElem);

	
	CString selValue;

	selValue = elemInfo;
	
    BSTR bstrVal = selValue.AllocSysString();
	

	IHTMLOptionElement* pOpt;	
	
	hr = m_pNewElem->QueryInterface(IID_IHTMLOptionElement, (void**)&pOpt);
	
	pOpt->put_text(bstrVal);

	
	//add elements.
	VARIANT index;

	index.vt = VT_I4;

    index.lVal = indexN;
	
	hr = m_SelElem->add(m_pNewElem,index);

	indexN = indexN + 1;
	
	
	::SysFreeString(bstrVal);
   	

    pOpt->Release();

}
